/*
  h_file.h   Nov98  JS  ---  please look at h_file.c for more infos
  
*/
#ifndef _H_FILE_H
#define _H_FILE_H

#include "config.h"
#include "defs.h"

/* ----------    packed-struct-array (obsolete) -----------------------
  struct thxy {			      // y,h[x,y] if(x=y)x++;
    int  xy __attribute__ ((packed)) ; // 4 Byte 
    char rr __attribute__ ((packed)) ; // 1 Byte 
  }; // 5 Byte packet, 8 Byte aligned!
 * __sparc-gcc2.7.2.3:    cplx=20Byte buserror in nhm hxy.rr=r;
 * __sgi-CC: no __attribute__ 
 * __hp9000s800-gcc2.7.0: cplx=20Byte buserror in nhm hxy.rr=r;
 * __alpha_ev5__-gcc2.95.2: cplx=20Byte unaligned trap at ... (/proc/kmsg)
 * 2D-array (struct of char[3],...) and own assignment-operator to slow
 * struct thxy { char xy[S_int], rr[S_char] } + casting-operatoren = same problem
 */

/*
  if HRMAX greater than 0,
  the program stores a index to the double or complex value of the matrix
  element, else the matrix element itself is stored to the disk
 --- if an error apears, choose xy as a next larger type ---
 --- please edit HRMAX too !!! ---
 unsigned char , unsigned int , ULong
 */
#ifndef HRMAX		/* can be defined in config.h */
#define HRMAX   1023  	/* 255, 1024 or higher, if ERR(9100), v2.33 */
#endif
#if   HRMAX<256
#define HR_TYPE	unsigned char	/* char bis 256 */
#elif HRMAX<65536
#define HR_TYPE	unsigned short	/* short bis 65536 */
#else
#define HR_TYPE	unsigned int	/* int bis 256^4 */
#endif

/* y-index + next-x-flag of H element */
#define BY_TYPE unsigned short  /* char,short,int = lg2(blocks*mpi) v2.33 */
#define XY_TYPE unsigned int	/* int or long */
#define XY_FLAG (((XY_TYPE)1)<<(sizeof(XY_TYPE)*8-1))	/* bit for last element in a line of H */ 

#if (!defined(HRMAX)) || (HRMAX<=0)
#define HR_TYPE scplx
#endif

/* number of elements per hnz-read-buffer (HBLen*(XYsize+HRsize))
 * for Tru64+SunOS and STOREH==4 set pipe.c:PBUFL to Hsize
 * example_ES45_v2.29 time[m]
 *  8,32 STOREH=0: HBLen=32K sh=0.87 i100=1.12, HBLen=1M sh=0.87 i100=1.37
 *  8,32 STOREH=2: HBLen=32K sh=0.87 i100=1.12, HBLen=1M sh=0.88 i100=1.25
 *  8,32 STOREH=4: HBLen=32K sh=0.87 i100=1.27, HBLen=1M sh=0.87 i100=1.52
 *  make HBLen bigger for more MPI nodes and slow network
 */
#ifndef HBLen    /* make it small, if H is not stored (no buffer needed) */
/* memory blocks should fit to L2 cache? not for MPI, blows up static size */
/*  but also defines (struct thxy) Hsize storage blocks (should be x*4kB) */
#define HBLen ( 32*1024) /* 32k*8B, big blocks to reduce system time */
#endif
/* structure to hold stored H-matrix elements
 * direct access to nonaligned members cause trap on IRIX ([].xy, [].r)
 *   therefore xy[],r[]
 */
struct thxy {		/* y,h[x,y] if(x=y)x++;   */
   /* ToDo: add xx (Hsize+30%) and sort to mpi-blocks (remove by),
            simpler mpi code (noXY_FLAG),
            faster mpi (const HBLen*XY_TYPE=mpi_pckt_size)?, +traffic/2
            xx,rr stored local, xy stored at remote node */
   /* extra data can be stored on first diag element xx and xy */
   XY_TYPE xy[HBLen];  	/* column y of element h[] (32bit idx + x.incr) */
   BY_TYPE by[HBLen];   /* block y  of element h[] (16bit mpi node) */
   HR_TYPE rr[HBLen];   /* [index to] NZ-Element (uchar,short,int,scplx) */
   /* ToDo: better variant b or c ???
      variant a) all elements + flag EOL
      variant b) const number of nondiag elements (max hnzline)
      variant c) diag (has coded num nondiag) + nondiag
     used to write blocks to disk/storage but also should fit to CPU cache
    */
};

#define Hsize sizeof(struct thxy)

#ifndef B_NUM
#error "we need B_NUM here defined in block.h"
#endif

extern int h_error;   /* set on write-error */
extern int h_state[B_NUM];    /* 0=closed, 1=ropen, 2=wopen */  


#if HRMAX>0
 /* table for 16bit(HR_SIZE) index to Hamilton-entries, one per thread */
 extern int  hr_len[B_NUM];
 extern cplx hr[B_NUM][HRMAX];
#endif

int h_ropen(int block);
int h_wopen(int block);
int h_rclose(int block);
int h_wclose(int block);
struct thxy *h_read(struct thxy *thb, int block);

/* store/read H-element, block, column=xy+Flag_next_line, value */
/* void h_put(int block, ULong  xx, ULong  xy, cplx  r); */
/* void h_get(int block, ULong *xx, ULong *xy, cplx *r); */
size_t my_fread( char *ptr, size_t size, size_t nmemb, int block);
size_t my_fwrite( void *ptr, size_t size, size_t nmemb, int block);
extern int h_state[B_NUM];    /* 0=closed, 1=ropen, 2=wopen */
void err_fulltable();

void ini_thxy(ULong n1);
/* if vvv outut info */
void h_checkpoint(int vvv);
void h_restore(int vvv);
#endif
